/**
 * Title: KeyboardJS
 * Version: v0.4.1
 * Description: KeyboardJS is a flexible and easy to use keyboard binding
 * library.
 * Author: Robert Hurst.
 *
 * Copyright 2011, Robert William Hurst
 * Licenced under the BSD License.
 * See https://raw.github.com/RobertWHurst/KeyboardJS/master/license.txt
 */

!function(e,n){function t(){function e(){var t;return t=n("amd"),t.fork=e,t}return e()}[].indexOf||(Array.prototype.indexOf=function(e,n,t){for(t=this.length,n=(t+~~n)%t;n<t&&(!(n in this)||this[n]!==e);n++);return n^t?n:-1}),"function"==typeof define&&define.amd?define(t):"undefined"!=typeof module?function(){function e(){var t;return t=n("CommonJS"),t.fork=e,t}module.exports=e()}():function(){function t(){function o(){var n,t;for(t=Array.prototype.slice.apply(arguments),n=0;n<a.length;n+=1)void 0===i[a[n]]?delete e[a[n]]:e[a[n]]=i[a[n]];for(i={},n=0;n<t.length;n+=1){if("string"!=typeof t[n])throw new Error("Cannot replace namespaces. All new namespaces must be strings.");i[t[n]]=e[t[n]],e[t[n]]=r}return a=t}var r,a=[],i={};return r=n("global"),r.fork=t,r.noConflict=o,r}var o;o=t(),o.noConflict("KeyboardJS","k")}()}(this,function(e){function n(){window.addEventListener?(document.addEventListener("keydown",r,!1),document.addEventListener("keyup",a,!1),window.addEventListener("blur",o,!1),window.addEventListener("webkitfullscreenchange",o,!1),window.addEventListener("mozfullscreenchange",o,!1)):window.attachEvent&&(document.attachEvent("onkeydown",r),document.attachEvent("onkeyup",a),window.attachEvent("onblur",o))}function t(){o(),window.removeEventListener?(document.removeEventListener("keydown",r,!1),document.removeEventListener("keyup",a,!1),window.removeEventListener("blur",o,!1),window.removeEventListener("webkitfullscreenchange",o,!1),window.removeEventListener("mozfullscreenchange",o,!1)):window.detachEvent&&(document.detachEvent("onkeydown",r),document.detachEvent("onkeyup",a),window.detachEvent("onblur",o))}function o(e){K=[],u(),g(e)}function r(e){var n,t,o;if(n=i(e.keyCode),!(n.length<1)){for(e.isRepeat=!1,o=0;o<n.length;o+=1)t=n[o],-1!=C().indexOf(t)&&(e.isRepeat=!0),E(t);s(),d(e)}}function a(e){var n,t;if(n=i(e.keyCode),!(n.length<1)){for(t=0;t<n.length;t+=1)x(n[t]);u(),g(e)}}function i(e){return L[e]||[]}function c(e){var n;for(n in L)if(L.hasOwnProperty(n)&&L[n].indexOf(e)>-1)return n;return!1}function f(e,n){if("string"!=typeof e&&("object"!=typeof e||"function"!=typeof e.push))throw new Error("Cannot create macro. The combo must be a string or array.");if("object"!=typeof n||"function"!=typeof n.push)throw new Error("Cannot create macro. The injectedKeys must be an array.");T.push([e,n])}function l(e){var n;if("string"!=typeof e&&("object"!=typeof e||"function"!=typeof e.push))throw new Error("Cannot remove macro. The combo must be a string or array.");for(mI=0;mI<T.length;mI+=1)if(n=T[mI],y(e,n[0])){x(n[1]),T.splice(mI,1);break}}function s(){var e,n,t;for(e=0;e<T.length;e+=1)if(n=w(T[e][0]),-1===F.indexOf(T[e])&&b(n))for(F.push(T[e]),t=0;t<T[e][1].length;t+=1)E(T[e][1][t])}function u(){var e,n,t;for(e=0;e<F.length;e+=1)if(n=w(F[e][0]),!1===b(n)){for(t=0;t<F[e][1].length;t+=1)x(F[e][1][t]);F.splice(e,1),e-=1}}function h(e,n,t){function o(){var e;for(e=0;e<l.length;e+=1)q.splice(q.indexOf(l[e]),1)}function r(e){function n(){var n,o;for(n=0;n<t.length;n+=1)if("function"==typeof t[n])if("keyup"===e)for(o=0;o<l.length;o+=1)l[o].keyUpCallback.splice(l[o].keyUpCallback.indexOf(t[n]),1);else for(o=0;o<l.length;o+=1)l[o].keyDownCallback.splice(l[o].keyDownCallback.indexOf(t[n]),1)}var t,o,r,a={};if("string"!=typeof e)throw new Error("Cannot bind callback. The event name must be a string.");if("keyup"!==e&&"keydown"!==e)throw new Error('Cannot bind callback. The event name must be a "keyup" or "keydown".');for(t=Array.prototype.slice.apply(arguments,[1]),o=0;o<t.length;o+=1)if("function"==typeof t[o])if("keyup"===e)for(r=0;r<l.length;r+=1)l[r].keyUpCallback.push(t[o]);else if("keydown"===e)for(r=0;r<l.length;r+=1)l[r].keyDownCallback.push(t[o]);return a.clear=n,a}var a,i,c,f={},l=[];for("string"==typeof e&&(e=w(e)),i=0;i<e.length;i+=1){if(a={},"string"!=typeof(c=v([e[i]])))throw new Error("Failed to bind key combo. The key combo must be string.");a.keyCombo=c,a.keyDownCallback=[],a.keyUpCallback=[],n&&a.keyDownCallback.push(n),t&&a.keyUpCallback.push(t),q.push(a),l.push(a)}return f.clear=o,f.on=r,f}function p(e){var n,t;for(n=0;n<q.length;n+=1)t=q[n],y(e,t.keyCombo)&&(q.splice(n,1),n-=1)}function m(e){var n,t,o;if(e){for(n=0;n<q.length;n+=1)for(o=q[n],t=0;t<o.keyCombo.length;t+=1)if(o.keyCombo[t].indexOf(e)>-1){q.splice(n,1),n-=1;break}}else q=[]}function d(e){var n,t,o,r,a,i,c,f,l,s,u,h=[];for(a=[].concat(K),n=0;n<q.length;n+=1)u=k(q[n].keyCombo).length,h[u]||(h[u]=[]),h[u].push(q[n]);for(t=h.length-1;t>=0;t-=1)if(h[t])for(n=0;n<h[t].length;n+=1){for(o=h[t][n],r=k(o.keyCombo),l=!0,f=0;f<r.length;f+=1)if(-1===a.indexOf(r[f])){l=!1;break}if(l&&b(o.keyCombo)){for(z.push(o),f=0;f<r.length;f+=1)(s=a.indexOf(r[f]))>-1&&(a.splice(s,1),f-=1);for(i=0;i<o.keyDownCallback.length;i+=1)!1===o.keyDownCallback[i](e,C(),o.keyCombo)&&(c=!0);!0===c&&(e.preventDefault(),e.stopPropagation())}}}function g(e){var n,t,o,r;for(n=0;n<z.length;n+=1)if(o=z[n],!1===b(o.keyCombo)){for(t=0;t<o.keyUpCallback.length;t+=1)!1===o.keyUpCallback[t](e,C(),o.keyCombo)&&(r=!0);!0===r&&(e.preventDefault(),e.stopPropagation()),z.splice(n,1),n-=1}}function y(e,n){var t,o,r;if(e=w(e),n=w(n),e.length!==n.length)return!1;for(t=0;t<e.length;t+=1){if(e[t].length!==n[t].length)return!1;for(o=0;o<e[t].length;o+=1){if(e[t][o].length!==n[t][o].length)return!1;for(r=0;r<e[t][o].length;r+=1)if(-1===n[t][o].indexOf(e[t][o][r]))return!1}}return!0}function b(e){var n,t,o,r,a,i,c=0;for(e=w(e),n=0;n<e.length;n+=1){for(i=!0,c=0,t=0;t<e[n].length;t+=1){for(o=[].concat(e[n][t]),r=c;r<K.length;r+=1)(a=o.indexOf(K[r]))>-1&&(o.splice(a,1),c=r);if(0!==o.length){i=!1;break}}if(i)return!0}return!1}function k(e){var n,t,o=[];for(e=w(e),n=0;n<e.length;n+=1)for(t=0;t<e[n].length;t+=1)o=o.concat(e[n][t]);return o}function w(e){var n=e,t=0,o=0,r=!1,a=!1,i=[],c=[],f=[],l="";if("object"==typeof e&&"function"==typeof e.push)return e;if("string"!=typeof e)throw new Error('Cannot parse "keyCombo" because its type is "'+typeof e+'". It must be a "string".');for(;" "===n.charAt(t);)t+=1;for(;;){if(" "===n.charAt(t)){for(;" "===n.charAt(t);)t+=1;r=!0}else if(","===n.charAt(t)){if(o||a)throw new Error("Failed to parse key combo. Unexpected , at character index "+t+".");a=!0,t+=1}else if("+"===n.charAt(t)){if(l.length&&(f.push(l),l=""),o||a)throw new Error("Failed to parse key combo. Unexpected + at character index "+t+".");o=!0,t+=1}else if(">"===n.charAt(t)){if(l.length&&(f.push(l),l=""),f.length&&(c.push(f),f=[]),o||a)throw new Error("Failed to parse key combo. Unexpected > at character index "+t+".");o=!0,t+=1}else if(t<n.length-1&&"!"===n.charAt(t)&&(">"===n.charAt(t+1)||","===n.charAt(t+1)||"+"===n.charAt(t+1)))l+=n.charAt(t+1),o=!1,r=!1,a=!1,t+=2;else{if(!(t<n.length&&"+"!==n.charAt(t)&&">"!==n.charAt(t)&&","!==n.charAt(t)&&" "!==n.charAt(t))){t+=1;continue}for((!1===o&&!0===r||!0===a)&&(l.length&&(f.push(l),l=""),f.length&&(c.push(f),f=[]),c.length&&(i.push(c),c=[])),o=!1,r=!1,a=!1;t<n.length&&"+"!==n.charAt(t)&&">"!==n.charAt(t)&&","!==n.charAt(t)&&" "!==n.charAt(t);)l+=n.charAt(t),t+=1}if(t>=n.length){l.length&&(f.push(l),l=""),f.length&&(c.push(f),f=[]),c.length&&(i.push(c),c=[]);break}}return i}function v(e){var n,t,o=[];if("string"==typeof e)return e;if("object"!=typeof e||"function"!=typeof e.push)throw new Error("Cannot stringify key combo.");for(n=0;n<e.length;n+=1){for(o[n]=[],t=0;t<e[n].length;t+=1)o[n][t]=e[n][t].join(" + ");o[n]=o[n].join(" > ")}return o.join(" ")}function C(){return[].concat(K)}function E(e){if(e.match(/\s/))throw new Error("Cannot add key name "+e+" to active keys because it contains whitespace.");K.indexOf(e)>-1||K.push(e)}function x(e){var n=c(e);"91"===n||"92"===n?K=[]:K.splice(K.indexOf(e),1)}function A(e,n){if("string"!=typeof e)throw new Error("Cannot register new locale. The locale name must be a string.");if("object"!=typeof n)throw new Error("Cannot register "+e+" locale. The locale map must be an object.");if("object"!=typeof n.map)throw new Error("Cannot register "+e+" locale. The locale map is invalid.");n.macros||(n.macros=[]),I[e]=n}function O(e){if(e){if("string"!=typeof e)throw new Error("Cannot set locale. The locale name must be a string.");if(!I[e])throw new Error("Cannot set locale to "+e+" because it does not exist. If you would like to submit a "+e+" locale map for KeyboardJS please submit it at https://github.com/RobertWHurst/KeyboardJS/issues.");L=I[e].map,T=I[e].macros,j=e}return j}var j,L,T,U,D,S={},I={},K=[],q=[],z=[],F=[];for(D={map:{3:["cancel"],8:["backspace"],9:["tab"],12:["clear"],13:["enter"],16:["shift"],17:["ctrl"],18:["alt","menu"],19:["pause","break"],20:["capslock"],27:["escape","esc"],32:["space","spacebar"],33:["pageup"],34:["pagedown"],35:["end"],36:["home"],37:["left"],38:["up"],39:["right"],40:["down"],41:["select"],42:["printscreen"],43:["execute"],44:["snapshot"],45:["insert","ins"],46:["delete","del"],47:["help"],91:["command","windows","win","super","leftcommand","leftwindows","leftwin","leftsuper"],92:["command","windows","win","super","rightcommand","rightwindows","rightwin","rightsuper"],145:["scrolllock","scroll"],186:["semicolon",";"],187:["equal","equalsign","="],188:["comma",","],189:["dash","-"],190:["period","."],191:["slash","forwardslash","/"],192:["graveaccent","`"],219:["openbracket","["],220:["backslash","\\"],221:["closebracket","]"],222:["apostrophe","'"],48:["zero","0"],49:["one","1"],50:["two","2"],51:["three","3"],52:["four","4"],53:["five","5"],54:["six","6"],55:["seven","7"],56:["eight","8"],57:["nine","9"],96:["numzero","num0"],97:["numone","num1"],98:["numtwo","num2"],99:["numthree","num3"],100:["numfour","num4"],101:["numfive","num5"],102:["numsix","num6"],103:["numseven","num7"],104:["numeight","num8"],105:["numnine","num9"],106:["nummultiply","num*"],107:["numadd","num+"],108:["numenter"],109:["numsubtract","num-"],110:["numdecimal","num."],111:["numdevide","num/"],144:["numlock","num"],112:["f1"],113:["f2"],114:["f3"],115:["f4"],116:["f5"],117:["f6"],118:["f7"],119:["f8"],120:["f9"],121:["f10"],122:["f11"],123:["f12"]},macros:[["shift + `",["tilde","~"]],["shift + 1",["exclamation","exclamationpoint","!"]],["shift + 2",["at","@"]],["shift + 3",["number","#"]],["shift + 4",["dollar","dollars","dollarsign","$"]],["shift + 5",["percent","%"]],["shift + 6",["caret","^"]],["shift + 7",["ampersand","and","&"]],["shift + 8",["asterisk","*"]],["shift + 9",["openparen","("]],["shift + 0",["closeparen",")"]],["shift + -",["underscore","_"]],["shift + =",["plus","+"]],["shift + (",["opencurlybrace","opencurlybracket","{"]],["shift + )",["closecurlybrace","closecurlybracket","}"]],["shift + \\",["verticalbar","|"]],["shift + ;",["colon",":"]],["shift + '",["quotationmark",'"']],["shift + !,",["openanglebracket","<"]],["shift + .",["closeanglebracket",">"]],["shift + /",["questionmark","?"]]]},U=65;U<=90;U+=1)D.map[U]=String.fromCharCode(U+32),D.macros.push(["shift + "+String.fromCharCode(U+32)+", capslock + "+String.fromCharCode(U+32),[String.fromCharCode(U)]]);return A("us",D),O("us"),n(),S.enable=n,S.disable=t,S.activeKeys=C,S.on=h,S.clear=p,S.clear.key=m,S.locale=O,S.locale.register=A,S.macro=f,S.macro.remove=l,S.key={},S.key.name=i,S.key.code=c,S.combo={},S.combo.active=b,S.combo.parse=w,S.combo.stringify=v,S});